_ace.exportUnityCFileFormat = {};

_ace.exportUnityCFileFormat.NavigationButtonsHtml = function(){

	var html = '';
	html += '<ul class="Menu">';
	html += '<li class="MenuItem"><a onclick="_ace.exportUnityCFileFormat.exportButton()" class="Button">Export Unity 3d C# Format</a></li>';
	html += '</ul>';
	return html;
	
}

_ace.App.create.topNavigationHtmlFunctionArray.push(_ace.exportUnityCFileFormat.NavigationButtonsHtml);

_ace.exportUnityCFileFormat.exportButton = function(){

	var i = 0; 
	var ii = 0;
	var iii = 0;
	var j = 0;
	var jj = 0;
	var tileSetCount;
	var levelCount;
	var layerCount;
	var tileCount;
	var arrayOfTileSetIndexes;
	var TileSetZero;
	
	if(_ace.currentProject.STRING_application!=undefined){

		var string = "";
		string += '/* Made With A Tile Map Editor 2 */<br>';
		string += '/* Ola Persson - 2019 - www.olapersson.com */<br>';
		string += '<br>';
		string += '/* Create a C# named aTileMapEditor2Level and add this code. */<br>';
		string += '/* No indentation is added, I did\'t want to mess up the browser code...*/<br>';
		string += '<br>';
		
		
		string += '/* --- Using ---*/<br>';
		
		string += 'using System.Collections;<br>';
		string += 'using System.Collections.Generic;<br>';
		string += 'using UnityEngine;<br>';
		string += '<br>';
		
		string += '/* --- Classes ---*/<br>';
		string += '<br>';
		string += 'public class GameFile<br>{<br>';
			string += 'public string gameName;<br>';
			string += 'public intVector2 originalScreenSize;<br>';
			string += 'public TileSet[] tileSets;<br>';
			string += 'public Level[] levels;<br>';
		string += '}<br>';
		string += '<br>';
		string += 'public class intVector2<br>{<br>';
			string += 'public int theX;<br>';
			string += 'public int theY;<br>';
		string += '}<br>';
		string += '<br>';
		string += 'public class TileSet<br>{<br>';
			string += 'public string tileSetName;<br>';
			string += 'public Material tileSetMaterial;<br>';
			string += 'public intVector2 pixelStartPosition;<br>';
			string += 'public intVector2 tilePixelSize;<br>';
			string += 'public intVector2 pixelSpaceBetweenTiles;<br>';
			string += 'public intVector2 tileCount;<br>';
			string += 'public int airTileIndex;<br>';
		string += '}<br>';
		string += '<br>';
		string += 'public class Level<br>{<br>';
			string += 'public string levelName;<br>';
			string += 'public string textString;<br>';
			string += 'public intVector2 levelPixelSize;<br>';
			string += 'public int tileZoomFactor;<br>';
			string += 'public TileMapLayer[] arrayOfLayers;<br>';
		string += '}<br>';
		string += '<br>';
		string += 'public class TileMapLayer<br>{<br>';
			string += 'public string layerName;<br>';
			string += 'public Vector2 parallaxSpeed;<br>';
			string += 'public intVector2 mapTileSize;<br>';
			string += 'public intVector2 tileGridPixelSize;<br>';
			string += 'public Tile[] map;<br>';
		string += '}<br>';
		string += '<br>';
		string += 'public class Tile<br>{<br>';
			string += 'public int tileIndex;<br>';
			string += 'public int tileSetIndex;<br>';
			string += 'public string textString;<br>';
			string += 'public string tag;<br>';
		string += '}<br>';
		string += '<br>';
		
		
		string += 'public class aTileMapEditor2Level : MonoBehaviour<br>{<br>';
		
		
		
		string += '/*--- Variables ---*/<br>';
		string += '<br>';
		string += 'public GameFile gameFile;<br>';
		
		tileSetCount = _ace.currentProject.tileSets.length;
		
		for(i=0; i<tileSetCount; i++){
			string += 'public Material tileSetMaterial'+i+';<br>';
		}
		
		string += '<br>';
		string += '/*--- Methods ---*/<br>';
		string += '<br>';
		string += 'void InitiateLevel()<br>{<br>';
		
			string += 'gameFile = new GameFile();<br>';

			string += 'gameFile.gameName = "'+_ace.currentProject.STRING_name+'";<br>';
			string += 'gameFile.originalScreenSize = new intVector2();<br>';
			string += 'gameFile.originalScreenSize.theX = '+_ace.currentProject.parallaxMode.INTEGER_screenSizeWidth+';<br>';
			string += 'gameFile.originalScreenSize.theY = '+_ace.currentProject.parallaxMode.INTEGER_screenSizeHeight+';<br>';
			string += '<br>';
			
			
			
			string += '/*--- Tile Sets ---*/<br>';
			string += '<br>';
			string += 'gameFile.tileSets = new TileSet['+tileSetCount+'];<br>';
			
			for(i = 0; i < tileSetCount; i++){
				string += '<br>';
				string += 'gameFile.tileSets['+i+'] = new TileSet();<br>';
				string += 'gameFile.tileSets['+i+'].tileSetName = "'+_ace.currentProject.tileSets[i].STRING_tileSetName+'";<br>';
				string += 'gameFile.tileSets['+i+'].tileSetMaterial = tileSetMaterial'+i+';<br>';
				string += 'gameFile.tileSets['+i+'].pixelStartPosition = new intVector2();<br>';
				string += 'gameFile.tileSets['+i+'].pixelStartPosition.theX = '+_ace.currentProject.tileSets[i].pixelStartPosition.INTEGER_x+';<br>';
				string += 'gameFile.tileSets['+i+'].pixelStartPosition.theY = '+_ace.currentProject.tileSets[i].pixelStartPosition.INTEGER_y+';<br>';
				string += 'gameFile.tileSets['+i+'].tilePixelSize = new intVector2();<br>';
				string += 'gameFile.tileSets['+i+'].tilePixelSize.theX = '+_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width+';<br>';
				string += 'gameFile.tileSets['+i+'].tilePixelSize.theY = '+_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height+';<br>';
				string += 'gameFile.tileSets['+i+'].pixelSpaceBetweenTiles = new intVector2();<br>';
				string += 'gameFile.tileSets['+i+'].pixelSpaceBetweenTiles.theX = '+_ace.currentProject.tileSets[i].pixelSpaceBetweenTiles.INTEGER_x+';<br>';
				string += 'gameFile.tileSets['+i+'].pixelSpaceBetweenTiles.theY = '+_ace.currentProject.tileSets[i].pixelSpaceBetweenTiles.INTEGER_y+';<br>';
				string += 'gameFile.tileSets['+i+'].tileCount = new intVector2();<br>';
				string += 'gameFile.tileSets['+i+'].tileCount.theX = '+_ace.currentProject.tileSets[i].tileCount.INTEGER_tilesWide+';<br>';
				string += 'gameFile.tileSets['+i+'].tileCount.theY = '+_ace.currentProject.tileSets[i].tileCount.INTEGER_tilesHigh+';<br>';
				string += 'gameFile.tileSets['+i+'].airTileIndex = '+_ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_airTile+';<br>';
				string += '<br>';
			}
			
			levelCount = _ace.currentProject.arrayOfLevels.length;
			
			string += '/*--- Levels ---*/<br>';
			string += '<br>';
			string += 'gameFile.levels = new Level['+levelCount+'];<br>';
			string += '<br>';
			
			for(i = 0; i < levelCount; i++){
			
				layerCount = _ace.currentProject.arrayOfLevels[i].arrayOfLayers.length;
				
			
				string += '/*--- Level '+i+' ---*/<br>';
				string += '<br>';
				string += 'gameFile.levels['+i+'] = new Level();<br>';
				string += 'gameFile.levels['+i+'].levelName = "'+_ace.currentProject.arrayOfLevels[i].STRING_levelName+'";<br>';
				string += 'gameFile.levels['+i+'].textString = "'+_ace.currentProject.arrayOfLevels[i].STRING_textString+'";<br>';
				string += 'gameFile.levels['+i+'].levelPixelSize = new intVector2();<br>';
				string += 'gameFile.levels['+i+'].levelPixelSize.theX = '+_ace.currentProject.arrayOfLevels[i].levelPixelSize.INTEGER_width+';<br>';
				string += 'gameFile.levels['+i+'].levelPixelSize.theY = '+_ace.currentProject.arrayOfLevels[i].levelPixelSize.INTEGER_height+';<br>';
				string += 'gameFile.levels['+i+'].tileZoomFactor = '+_ace.currentProject.arrayOfLevels[i].FLOAT_tileZoomFactor+';<br>';
			
				string += '<br>';
				string += 'gameFile.levels['+i+'].arrayOfLayers = new TileMapLayer['+layerCount+'];<br>';
				string += '<br>';
			
				for(ii=0; ii<layerCount; ii++){
					
					tileCount = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map.length;
					arrayOfTileSetIndexes = [];
				
					for(j = 0; j<_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].ARRAY_useTileSetsWithIdentifyer.length; j++){
						for(jj = 0; jj<_ace.currentProject.tileSets.length; jj++){
							if(_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].ARRAY_useTileSetsWithIdentifyer[j] == _ace.currentProject.tileSets[jj].STRING_tileSetIdentifyer){
								arrayOfTileSetIndexes.push(jj);
								break;
							}
						}
					}
					
					TileSetZero = _ace.currentProject.tileSets[arrayOfTileSetIndexes[0]];
									
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'] = new TileMapLayer();<br>';
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].layerName = "'+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_layerName+'";<br>';
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].parallaxSpeed = new Vector2('+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].parallaxSpeed.FLOAT_x+'f, '+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].parallaxSpeed.FLOAT_y+'f);<br>';
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].mapTileSize = new intVector2();<br>';
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].mapTileSize.theX = '+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].mapSize.INTEGER_width+';<br>';
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].mapTileSize.theY = '+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].mapSize.INTEGER_height+';<br>';
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].tileGridPixelSize = new intVector2();<br>';
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].tileGridPixelSize.theX = '+TileSetZero.tilePixelSize.INTEGER_width+';<br>';
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].tileGridPixelSize.theY = '+TileSetZero.tilePixelSize.INTEGER_height+';<br>';
					string += '<br>';
					
					string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].map = new Tile['+tileCount+'];<br>';
					
					for(iii=0; iii<tileCount; iii++){
						string += '<br>';
						string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].map['+iii+'] = new Tile();<br>';
						string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].map['+iii+'].tileIndex = '+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map[iii].INTEGER_tileIndex+';<br>';
						string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].map['+iii+'].tileSetIndex = '+arrayOfTileSetIndexes[_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map[iii].INTEGER_tileSetIndex]+';<br>';
						string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].map['+iii+'].textString = "'+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map[iii].STRING_textString+'";<br>';
						string += 'gameFile.levels['+i+'].arrayOfLayers['+ii+'].map['+iii+'].tag = "'+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map[iii].STRING_tag+'";<br>';
					}
				}
				string += '<br>';
			}
			
			
		string += '}<br>';
		string += '<br>';
		string += 'void Awake()<br>{<br>';
			string += 'InitiateLevel();<br>';
		string += '}<br>';
		
		string += '}<br>';
		
		var html = '<span class="PromptBoxTitle">Copy This Level Object (String)</span><div class="SaveLevelString" id="SaveLevelStringId">' + string + "</div>";
		_ace.prompt({}, "", html);

		_ace.GeneralFunctions.SelectTextInsideId("SaveLevelStringId");

	} else {
		_ace.prompt({}, "","No Project File Found. Create One By Clicking \"New Project\"");
	}
}







_ace.exportUnityCFileFormat.createStandalone = function(){
	
	var theProject = jQuery.extend(true, {}, _ace.currentProject);
	theProject.styleSheets = null;
	theProject.resources.fonts = jQuery.extend(true, [], _ace.fontManagement.base64Fonts);
	theProject.animationStyles = jQuery.extend(true, [], _ace.animationManagement.animationStyles);

	theProject = _ace.exportUnityCFileFormat.escapeNewLineInTextStrings(theProject);
	theProject = _ace.exportUnityCFileFormat.removeFontsNotUsed(theProject);
	theProject = _ace.exportUnityCFileFormat.removeImagesNotUsed(theProject);
	theProject = _ace.exportUnityCFileFormat.removeAnimationStylesNotUsed(theProject);
	
	var string;
	var singleOutputFormatProject;
	var theOutputObject;
	var theFileName;
	// console.log(theProject);
	for(var i = 0; i < theProject.outputFormatArray.length; i++){
		singleOutputFormatProject = jQuery.extend(true, {}, theProject);
		theOutputObject = singleOutputFormatProject.outputFormatArray.splice(i,1); 
		singleOutputFormatProject.outputFormatArray = theOutputObject;
		string = '(function () {';
		
		string += _ace.exportUnityCFileFormat.standAlonePlayerScript();
		string += "_ace.currentProject="+_ace.GeneralFunctions.ConvertToString(singleOutputFormatProject);
		string += '}());';
		theFileName = singleOutputFormatProject.name + "_" + theOutputObject[0].name + "_" + theOutputObject[0].size.x +"x"+theOutputObject[0].size.y;
		theFileName = _ace.GeneralFunctions.convertToFilename(theFileName);
		theFileName += ".js";
		_ace.exportUnityCFileFormat.createDownloadableJsFile(string, theFileName, theFileName);
	}

	
}


_ace.exportUnityCFileFormat.escapeNewLineInTextStrings = function(theProject){
	for(var i = 0; i < theProject.arrayOfLevels.length; i++){
		for(var ii = 0; ii < theProject.arrayOfLevels[i].arrayOfLayers.length; ii++){
			if(theProject.arrayOfLevels[i].arrayOfLayers[ii].type == "text"){
				theProject.arrayOfLevels[i].arrayOfLayers[ii].string = theProject.arrayOfLevels[i].arrayOfLayers[ii].string.replace(/\n/g, "\\n");
			}
		}
	}
	return theProject;
}



_ace.exportUnityCFileFormat.createDownloadableJsFile = function(theString, fileName, downloadTitle){

	// theString = theString.replace(/_ace/g, "_"+Math.random().toString(36).substr(2, 9));
	
	// var textToWrite = document.getElementById("inputTextToSave").value;
	// var textFileAsBlob = new Blob([theString], {type:'text/plain'});
	var textFileAsBlob = new Blob([theString], {type:'text/javascript'});
	var fileNameToSaveAs = fileName; // document.getElementById("inputFileNameToSaveAs").value;

	var downloadLink = document.createElement("a");
	downloadLink.download = fileNameToSaveAs;
	downloadLink.innerHTML = downloadTitle;
	downloadLink.className = "DownloadLink";
	
	
	
	if (window.webkitURL != null)
	{
		// Chrome allows the link to be clicked
		// without actually adding it to the DOM.
		downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
	}
	else
	{
		// Firefox requires the link to be added to the DOM
		// before it can be clicked.
		downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
		// downloadLink.onclick = destroyClickedElement;
		// downloadLink.style.display = "none";
		// document.body.appendChild(downloadLink);
	}
	
	$("#DownloadFiles").append(downloadLink);

	// downloadLink.click();
}


