/* Original Code By Remy Sharp */
/* https://github.com/remy */
/* Modified By Ola Persson */


var _diu = {};

_diu.holder;
_diu.arrayOfCurrentDrops = [];

_diu.previewfile = function(file) {
  if (_diu.tests.filereader === true && _diu.acceptedTypes[file.type] === true) {
    var reader = new FileReader();
    reader.onload = function (event) {
		_ace.resourceManagement.addBase64Image(event);
    };
    reader.readAsDataURL(file);
  }  else {
    _diu.holder.innerHTML += '<p>Uploaded ' + file.name + ' ' + (file.size ? (file.size/1024|0) + 'K' : '');
    console.log(file);
  }
}

_diu.readfiles = function(files) {
    // debugger;
    var formData = _diu.tests.formdata ? new FormData() : null;
    for (var i = 0; i < files.length; i++) {
      if (_diu.tests.formdata) formData.append('file', files[i]);
      _diu.previewfile(files[i]);
    }
}

_diu.sendFormData = function(formData){
	return;
    // now post a new XHR request
    if (_diu.tests.formdata) {
      var xhr = new XMLHttpRequest();
      xhr.open('POST', '/devnull.php');
      xhr.onload = function() {
        _diu.progress.value = _diu.progress.innerHTML = 100;
      };

      if (_diu.tests.progress) {
        xhr.upload.onprogress = function (event) {
          if (event.lengthComputable) {
            var complete = (event.loaded / event.total * 100 | 0);
            _diu.progress.value = _diu.progress.innerHTML = _diu.complete;
          }
        }
      }

      _diu.sendFormData(formData);
    }
}

_diu.turnElementByIdIntoDropArea = function(theElementId){
	_diu.holder = document.getElementById(theElementId)
	_diu.tests = {
	  filereader: typeof FileReader != 'undefined',
	  dnd: 'draggable' in document.createElement('span'),
	  formdata: !!window.FormData,
	  progress: "upload" in new XMLHttpRequest
	};
	_diu.support = {
	  filereader: null,//document.getElementById('filereader'),
	  formdata: null,//document.getElementById('formdata'),
	  progress: null//document.getElementById('progress')
	};
	_diu.acceptedTypes = {
	  'image/png': true,
	  'image/jpeg': true,
	  'image/gif': true
	};
	_diu.progress = document.getElementById('uploadprogress');
	_diu.fileupload = document.getElementById('upload');
	
	if (_diu.tests.dnd) { 
	  _diu.holder.ondragover = function () { 
		  // this.className = 'hover'; 
		  return false; 
	  };
	  _diu.holder.ondragend = function () { 
		  // this.className = ''; 
		  return false; 
	  };
	  _diu.holder.ondrop = function (e) {
		  var currentObject;
		  currentObjectPath = $(e.explicitOriginalTarget).parent().attr('id');
		  
		  var theObjectKey = currentObjectPath;
		  theObjectKey = theObjectKey.split("-");

		  switch(theObjectKey.length-1){
		  	case 1 : 
				currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]];
			break; 
			case 2 :
				currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]];
			break;
			case 3 :
				currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]];
			break;
			case 4 :
				currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]];
			break;
			case 5 :
				currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]];
			break;
			case 6 :
				currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]][theObjectKey[5]];
			break;
		}
 
		var currentDrop = {
			droppedFileSize : e.dataTransfer.files[0].size,
			parentObject : currentObject,
			assigned : false
		}
		 
		_diu.arrayOfCurrentDrops.push(currentDrop);
		
	    e.preventDefault();
	    _diu.readfiles(e.dataTransfer.files);
		
	  }
	} else {
	  // _diu.fileupload.className = 'hidden';
	  _diu.fileupload.querySelector('input').onchange = function () {
	    _diu.readfiles(this.files);
	  };
	}
	
}


